<template>
  <cdx-dialog
    :open="open"
    title="Nearby"
    close-button-label="Close"
    :primary-action="primaryAction"
    :default-action="defaultAction"
    class="text-black"
    @update:open="emit('update:open', false)"
    @primary="nearbySubmit"
    @default="emit('update:open', false)"
  >
    <div class="mb-5">
      <p class="mb-1 font-medium">Coordinates</p>
      <CdxTextInput v-model="latitude" class="mb-3" placeholder="Latitude" />
      <CdxTextInput v-model="longitude" class="mb-3" placeholder="Longitude" />
      <p class="text-red-500 mb-2">{{ error }}</p>
      <CdxButton class="scale-110 origin-left" @click="getGeolocation">
        <CdxIcon :icon="cdxIconMapPin" />
      </CdxButton>
    </div>

    <div class="mb-6">
      <p class="font-medium mb-1">Number of words to get?</p>
      <CdxTextInput
        v-model="numberOfWords"
        input-type="number"
        class="mb-3"
        placeholder="Number of words"
      />
    </div>

    <cdx-toggle-switch v-model="removeRecordedWords"
      >Exclude words you have already recorded</cdx-toggle-switch
    >
  </cdx-dialog>
</template>

<script setup>
import {
  CdxButton,
  CdxField,
  CdxTextInput,
  CdxIcon,
  CdxDialog,
  CdxToggleSwitch,
} from '@wikimedia/codex'
import { cdxIconTrash, cdxIconLogoWikipedia, cdxIconMapPin } from '@wikimedia/codex-icons'
import { useRecordWizardStore } from '@/stores/recordwizard'
import makeApiCall from '@/utils/makeApiCall.js'
import { defineProps, defineEmits, ref } from 'vue'
import getLocutorRecordings from '@/utils/getLocutorRecordings.js'

const numberOfWords = ref(100)
const latitude = ref(null)
const longitude = ref(null)
const error = ref(null)
const removeRecordedWords = ref(false)

const props = defineProps({
  open: Boolean,
})

const emit = defineEmits(['update:open', 'canGoToNextStep'])

const store = useRecordWizardStore()

const primaryAction = {
  label: 'Save',
  actionType: 'progressive',
}

const defaultAction = {
  label: 'Cancel',
}

const getGeolocation = () => {
  if (navigator.geolocation) {
    navigator.geolocation.getCurrentPosition(setPosition, showError)
  } else {
    error.value = 'Geolocation is not supported by this browser.'
  }
}

// Function to set the position
const setPosition = (position) => {
  latitude.value = position.coords.latitude
  longitude.value = position.coords.longitude
  error.value = ''
}

// Function to handle errors
const showError = (errorEvent) => {
  switch (errorEvent.code) {
    case errorEvent.PERMISSION_DENIED:
      error.value = 'User denied the request for Geolocation.'
      break
    case errorEvent.POSITION_UNAVAILABLE:
      error.value = 'Location information is unavailable.'
      break
    case errorEvent.TIMEOUT:
      error.value = 'The request to get user location timed out.'
      break
    case errorEvent.UNKNOWN_ERROR:
      error.value = 'An unknown error occurred.'
      break
  }
}

async function nearbySubmit() {
  emit('update:open', false)
  const ids = await getTitleIds()
  let i = 0
  let currentIds = []
  let remainingWords = numberOfWords.value
  const finalWords = []
  let recordedWords
  if (removeRecordedWords.value) recordedWords = await getLocutorRecordings()

  while (remainingWords > 0 && i < ids.length) {
    currentIds.push(ids[i].title)
    i++
    if (i % 50 === 0 || i === ids.length) {
      let titles = await makeApiCall(
        'get',
        'https://www.wikidata.org/w/api.php',
        (error) => {},
        false,
        {},
        {},
        {
          format: 'json',
          origin: '*',
          formatversion: 2,
          action: 'wbgetentities',
          props: 'labels',
          languages: 'en',
          ids: currentIds.join('|'),
        },
      )
      titles = Object.values(titles.entities).map((item) => {
        return item.labels.en.value
      })
      if (removeRecordedWords.value)
        titles = titles.filter((title) => !recordedWords.includes(title))
      finalWords.push(...titles)
      remainingWords -= titles.length
      currentIds = []
    }
  }
  store.addWordsArray(finalWords.slice(0, numberOfWords.value))
  emit('canGoToNextStep')
}

const getTitleIds = async () => {
  const response = await makeApiCall(
    'get',
    'https://www.wikidata.org/w/api.php',
    (error) => {},
    false,
    {},
    {},
    {
      action: 'query',
      format: 'json',
      origin: '*',
      formatversion: 2,
      list: 'geosearch',
      gscoord: `${latitude.value}|${longitude.value}`,
      gsradius: 10000,
      gslimit: removeRecordedWords.value ? 1000000 : numberOfWords.value, // A very high limit to get all the words
    },
  )
  return response.query.geosearch
}
</script>
